

# This file was *autogenerated* from the file /home/thomas/puroba/TP2/ex3.sage
from sage.all_cmdline import *   # import sage library

_sage_const_1 = Integer(1); _sage_const_2 = Integer(2); _sage_const_4 = Integer(4); _sage_const_0 = Integer(0); _sage_const_500 = Integer(500); _sage_const_5 = Integer(5); _sage_const_6 = Integer(6)
d = _sage_const_1 /_sage_const_2 
q = _sage_const_1 /_sage_const_4 
M = Matrix(QQ, [[_sage_const_0 , q, q, q, q, _sage_const_0 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , d, _sage_const_0 , _sage_const_0 , _sage_const_0 , d],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , d, d, _sage_const_0 ],
            [_sage_const_0 , d, d, _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , d, d, _sage_const_0 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_1 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_1 ]])
Mp= Matrix(QQ, [[_sage_const_0 , q, q, q, q, _sage_const_0 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , d, _sage_const_0 , _sage_const_0 , _sage_const_0 , d],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , d, d, _sage_const_0 ],
            [_sage_const_0 , d, d, _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 ],
            [_sage_const_0 , _sage_const_0 , _sage_const_0 , d, d, _sage_const_0 , _sage_const_0 ],
            [_sage_const_1 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 ],
            [_sage_const_1 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 ]])
v =  vector(RR, [_sage_const_1 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 , _sage_const_0 ])
vpropre = Mp.eigenmatrix_left()
r1 = v * M**_sage_const_500 
print("Distribution de M à 500 itérations:")
print(r1)
print("==> Proba que j1 gagne : ", r1[_sage_const_5 ])
r2 = v * Mp**_sage_const_500 
print("Distribution de M' à 500 itérations:")
print(r2)
print("Distribution stationnaire de M' (vecteur propre):")
for vec in vpropre[_sage_const_1 ]:
    neg = false
    for c in vec:
        if c < _sage_const_0 :
            neg = true
    if neg:
        continue
    
    n = vec.norm(_sage_const_1 )
    if n == _sage_const_0 :
        continue
    r3 = vector(RR, vec/vec.norm(_sage_const_1 ))
    print(r3)
print("==> Proba que j1 gagne : ", r3[_sage_const_5 ] / (r3[_sage_const_5 ] + r3[_sage_const_6 ]))

